//
//  JiguangDemo
//
//  Created by xudong.rao on 2020/11/10.
//

#import "JOPERATEPopView.h"
#import "Toast.h"
#import "SDBaseTextView.h"

@interface JOPERATEPopView ()<UITextViewDelegate>
{
    NSString *lastContentString;
    float offsetY;
}
@property (strong, nonatomic) UIView *popView;
@property (strong, nonatomic) UILabel *titleLable;
@property (strong, nonatomic) UIImageView *iconView;
@property (strong, nonatomic) SDBaseTextView *textView;
@property (strong, nonatomic) UILabel *tipLabel;


@end

static NSInteger seq = 0;

@implementation JOPERATEPopView
- (NSInteger)seq {
  return ++ seq;
}
- (instancetype)initWithTitle:(NSString *)title placeholder:(NSString *)placeholder tip:(NSString *)tip maxCount:(NSInteger)maxCount{
    self = [super init];
    if (self) {
        self.title = title;
        self.placeholder = placeholder;
        self.maxCount = maxCount;
    }
    return self;
}
- (instancetype)init
{
    self = [super init];
    if (self) {
//        [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(textFiledEditChanged:) name:@"UITextViewTextDidChangeNotification" object:self.textView];
//        //键盘通知
        
        self.type = 1;
        self.maxCount = 40;
        self.placeholder = @"";
        
        _popView = [[UIView alloc] init];
        _popView.backgroundColor = RGB(245, 245, 245);
        _popView.layer.cornerRadius = 6;
        _popView.layer.masksToBounds = YES;
        [self addSubview:_popView];
        [_popView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_offset(Scale(304));
            make.height.mas_offset(Scale(232));
            make.centerX.equalTo(self.mas_centerX);
            make.centerY.equalTo(self.mas_centerY);
        }];
        
        self.iconView = [[UIImageView alloc] init];
        [_popView addSubview:self.iconView];
        
        self.titleLable = [[UILabel alloc] init];
        self.titleLable.font = [UIFont boldSystemFontOfSize:18];
        self.titleLable.text = self.title;
        [_popView addSubview:self.titleLable];
        
        self.textView = [[SDBaseTextView alloc] init];
        self.textView.layer.cornerRadius = 6;
        self.textView.layer.masksToBounds = YES;
        self.textView.delegate = self;
        if (self.text) {
            self.textView.text = self.text;
        }
        self.textView.placeholder = self.placeholder;
        self.textView.font = [UIFont systemFontOfSize:16];
        self.textView.backgroundColor = [UIColor whiteColor];
        [_popView addSubview:self.textView];
        [_textView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.height.mas_offset(Scale(Scale(72)));
            make.top.equalTo(_titleLable.mas_bottom).offset(Scale(12));
            make.left.equalTo(_popView.mas_left).offset(Scale(17));
            make.right.equalTo(_popView.mas_right).offset(Scale(-17));
        }];
        
        
        self.tipLabel = [[UILabel alloc] init];
        self.tipLabel.font = [UIFont systemFontOfSize:13];
        self.tipLabel.numberOfLines = 0;
        self.tipLabel.textColor = RGB(141, 147, 157);
        [_popView addSubview:self.tipLabel];
        [_tipLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.height.mas_offset(Scale(40));
            make.top.equalTo(_textView.mas_bottom).offset(Scale(8));
            make.left.equalTo(_textView.mas_left);
            make.right.equalTo(_textView.mas_right);
        }];
        
        UIButton *cancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [cancelBtn setTitle:@"取消" forState:UIControlStateNormal];
        cancelBtn.tag = 1;
        cancelBtn.backgroundColor = RGB(245, 245, 245);
        cancelBtn.titleLabel.font = [UIFont systemFontOfSize:16];
        [cancelBtn setTitleColor:RGB(142, 147, 157) forState:UIControlStateNormal];
        [cancelBtn addTarget:self action:@selector(didClickAction:) forControlEvents:UIControlEventTouchUpInside];
        [_popView addSubview:cancelBtn];
        
        UIButton *sureBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [sureBtn setTitle:@"确定" forState:UIControlStateNormal];
        sureBtn.tag = 2;
        sureBtn.backgroundColor = RGB(0, 132, 246);
        sureBtn.titleLabel.font = [UIFont systemFontOfSize:16];
        [sureBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [sureBtn addTarget:self action:@selector(didClickAction:) forControlEvents:UIControlEventTouchUpInside];
        [_popView addSubview:sureBtn];
        
        [cancelBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(_popView.mas_left);
            make.height.mas_equalTo(Scale(48));
            make.bottom.equalTo(_popView.mas_bottom);
            make.right.equalTo(sureBtn.mas_left);
            make.width.equalTo(sureBtn.mas_width);
        }];
        [sureBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(cancelBtn.mas_right);
            make.centerY.equalTo(cancelBtn.mas_centerY);
            make.right.equalTo(_popView.mas_right);
            make.height.equalTo(cancelBtn.mas_height);
            make.width.equalTo(cancelBtn.mas_width);
        }];
        
        UIView *line = [[UIView alloc] init];
        line.backgroundColor = RGB(205, 205, 205);;
        [_popView addSubview:line];
        [line mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(cancelBtn.mas_left);
            make.top.equalTo(cancelBtn.mas_top);
            make.width.equalTo(cancelBtn.mas_width);
            make.height.mas_equalTo(1);
        }];
    }
    return self;
}
- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"UITextViewTextDidChangeNotification" object:self.textView];
}

- (void)didClickAction:(UIButton *)button {
    if (self.subType == 2) {
        //bool类型单独处理
        if (self.popViewBlock) {
            self.popViewBlock(self.type, button.tag == 2 ? @"1" : @"0",YES);
        }
        return;
    }
    
    if (button.tag ==1) {
        NSLog(@"取消");
        [self.textView resignFirstResponder];
        [self removeFromSuperview];
    }else{
        NSLog(@"确定");
        if (self.subType == 1 && self.textView.text.length != 11) {
            return;
        }
        if (self.popViewBlock) {
            self.popViewBlock(self.type, _textView.text,YES);
        }
    }
    
}

- (void)show {
    self.titleLable.text = self.title;
    self.textView.placeholder = self.placeholder;
    if (self.text) {
        self.textView.text = self.text;
    }
    if (self.subType == 1) {
        self.textView.keyboardType = UIKeyboardTypeNumberPad;
    } else if (self.subType == 2) {
        [self.textView setHidden:YES];
        UIButton *cancelBtn = [self.popView viewWithTag:1];
        [cancelBtn setTitle:@"FALSE" forState:UIControlStateNormal];

        UIButton *sureBtn = [self.popView viewWithTag:2];
        [sureBtn setTitle:@"TRUE" forState:UIControlStateNormal];
    } else if (self.subType == 3) {
        [_textView mas_updateConstraints:^(MASConstraintMaker *make) {
            make.height.mas_offset(Scale(Scale(102)));
            make.top.equalTo(_titleLable.mas_bottom).offset(Scale(12));
            make.left.equalTo(_popView.mas_left).offset(Scale(17));
            make.right.equalTo(_popView.mas_right).offset(Scale(-17));
        }];
    }
    
    if (self.type == 1) {
        self.iconView.image = [UIImage imageNamed:self.icon];
       [self.iconView  mas_makeConstraints:^(MASConstraintMaker *make) {
            make.size.mas_equalTo(Scale(28));
            make.left.equalTo(_popView).offset(Scale(17));
            make.top.equalTo(_popView).offset(Scale(13));
        }];
    }
    
    [_titleLable mas_makeConstraints:^(MASConstraintMaker *make) {
        make.height.mas_offset(Scale(25));
        make.left.equalTo(_popView).offset(self.type == 1 ? Scale(55) : Scale(17));
        make.top.equalTo(_popView.mas_top).offset(Scale(16));
        make.right.equalTo(_popView);
        make.width.lessThanOrEqualTo(@(Scale(150)));
    }];
    [_tipLabel mas_updateConstraints:^(MASConstraintMaker *make) {
        make.height.mas_offset(!_tipMessage.length ? 0 : Scale(40));
        make.top.equalTo(_textView.mas_bottom).offset(Scale(8));
        make.left.equalTo(_textView.mas_left);
        make.right.equalTo(_textView.mas_right);
    }];
    [_popView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.width.mas_offset(Scale(304));
        if (self.subType == 2) {
            make.height.mas_offset(Scale(142));
        }else if (self.subType == 3) {
            make.height.mas_offset(Scale(243));
        } else {
            make.height.mas_offset(!_tipMessage.length ? Scale(192) : Scale(232));
        }
        make.centerX.equalTo(self.mas_centerX);
        make.centerY.equalTo(self.mas_centerY);
    }];
    self.frame = CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
    self.backgroundColor = [RGB(37, 48, 68) colorWithAlphaComponent:0.5];
    [[UIApplication sharedApplication].keyWindow addSubview:self];
}

- (void)dismiss{
    [self removeFromSuperview];
}

-(void)textViewDidChange:(UITextView *)textView{
    NSLog(@"change=%@",textView.text);
    if (self.subType == 1) {
        if (textView.text.length != 11) {
            self.tipLabel.textColor = RGB(218, 20, 20);
            self.tipLabel.text =self.tipMessage;
            self.textView.layer.borderColor = RGB(218, 20, 20).CGColor;
            self.textView.layer.borderWidth = 1;
        } else {
            self.textView.layer.borderColor = [UIColor whiteColor].CGColor;
            self.textView.layer.borderWidth = 1;
            self.tipLabel.textColor = RGB(141, 147, 157);
            self.tipLabel.text = @"";
        }
    }
}

- (void)textViewDidBeginEditing:(UITextView *)textView {

    offsetY = self.popView.frame.origin.y;
    CGRect rect = self.popView.frame;
    rect.origin.y =  rect.origin.y - 30;
    [UIView animateWithDuration:0.5 animations:^{
        self.popView.frame = rect;
    }];
}

- (void)textViewDidEndEditing:(UITextView *)textView {

    CGRect rect = self.popView.frame;
    rect.origin.y = offsetY;
    [UIView animateWithDuration:0.5 animations:^{
        self.popView.frame = rect;
    }];
}


-(void)touchesEnded:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.textView resignFirstResponder];
}



@end
