//
//  NavBar.m
//  JOperateDemo
//
//  Created by ys on 2021/11/19.
//

#import "NavBar.h"
#import "Masonry/Masonry.h"

@interface NavBar()

@property(nonatomic, weak) UIViewController* delegate;

@end


@implementation NavBar

- (instancetype)initWithTitle:(NSString *)title
                     delegate:(UIViewController*)delegate
                     withBack:(BOOL)ret {
    self = [super init];
    if (self) {
        
        self.delegate = delegate;
        [self layoutWithTitle:title withBack:ret];
    }
    return self;
}

- (void)layoutWithTitle:(NSString *)title
               withBack:(BOOL)ret {
    CGFloat safe = [UIScreen mainScreen].bounds.size.height > 736 ? 44 : 0;
    self.frame = CGRectMake(0, safe, [[UIScreen mainScreen] bounds].size.width, 54);
    self.backgroundColor = [UIColor whiteColor];
    
    UILabel *label = [[UILabel alloc] init];
    label.numberOfLines = 0;
    label.attributedText = [[NSMutableAttributedString alloc] initWithString:title attributes: @{NSFontAttributeName: [UIFont systemFontOfSize: 17],NSForegroundColorAttributeName: [UIColor colorWithRed:37/255.0 green:48/255.0 blue:68/255.0 alpha:1.0]}];;
    label.textAlignment = NSTextAlignmentCenter;
    label.alpha = 0.9;
    [self addSubview:label];
    
    UIView *lineView = [[UIView alloc] init];
    lineView.backgroundColor = UIColor.lightGrayColor;
    [self addSubview:lineView];
    
    [label mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self).offset(20);
        make.centerX.equalTo(self);
    }];
    
    [lineView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.left.width.equalTo(self);
        make.height.mas_equalTo(0.5);
    }];
    
    if (ret) {
        UIButton *backView = [[UIButton alloc] init];
        [backView setImage:[UIImage imageNamed:@"返回"] forState:UIControlStateNormal];
        [backView addTarget:self action:@selector(back) forControlEvents:UIControlEventTouchUpInside];
        
        [self addSubview:backView];
        [backView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self).offset(20);
            make.left.equalTo(self).offset(16);
        }];
    }
}

- (void)back {
    [self.delegate.navigationController popViewControllerAnimated:YES];
}

@end
