//
//  PresetController.m
//  JOperateDemo
//
//  Created by ys on 2021/11/26.
//

#import "PresetController.h"


@interface PresetController ()<UITableViewDelegate, UITableViewDataSource>

@property(nonatomic, strong) NavBar *navbar;
@property(nonatomic, strong) UITableView *tableView;
@property(nonatomic, strong) NSMutableArray *dataSource;

@end

@implementation PresetController


- (void)viewDidLoad {
    [super viewDidLoad];
    self.navbar = [[NavBar alloc] initWithTitle:@"预置事件属性" delegate:self withBack:YES];
    [self.view addSubview:self.navbar];
    self.view.backgroundColor = UIColor.whiteColor;
    
    [self layout];
    [self loadData];
}

- (void)layout {
    self.tableView = [[UITableView alloc] init];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [self.tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"cell"];
    [self.view addSubview:self.tableView];
    
    [self.tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.navbar.mas_bottom);
        make.left.width.bottom.equalTo(self.view);
    }];
}

- (void)loadData {
    self.dataSource = [[JOPERATEService peripheralData]  mutableCopy];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    [cell.contentView.subviews makeObjectsPerformSelector:@selector(removeFromSuperview)];
    
    NSDictionary *data = self.dataSource[indexPath.row];
    UILabel *label = [[UILabel alloc] init];
    label.frame = CGRectMake(Scale(16), Scale(20), Scale(130), Scale(20));
    [cell.contentView addSubview:label];
    label.attributedText = [[NSMutableAttributedString alloc] initWithString:data.allKeys[0] attributes: @{NSFontAttributeName: [UIFont systemFontOfSize: 14],NSForegroundColorAttributeName: kUIColorFromRGB(0x6B7381)}];
   
    UILabel *valueLabel = [[UILabel alloc] init];
    valueLabel.textColor = kUIColorFromRGB(0x253044);
    valueLabel.font = [UIFont systemFontOfSize:12.0];
    valueLabel.textAlignment = NSTextAlignmentRight;
    valueLabel.text = [data.allValues[0] isKindOfClass:[NSNumber class]] ? [data.allValues[0] stringValue] : data.allValues[0];
    [cell.contentView addSubview:valueLabel];
    
    [valueLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.height.equalTo(label.mas_height);
        make.centerY.equalTo(label.mas_centerY);
        make.right.equalTo(cell.contentView).offset(-Scale(16));
    }];
    
            
    UIView *line = [[UIView alloc] init];
    line.layer.backgroundColor = [UIColor colorWithRed:238/255.0 green:239/255.0 blue:247/255.0 alpha:1.0].CGColor;
    [cell.contentView addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(Scale(1));
        make.left.equalTo(cell.contentView.mas_left).offset(Scale(16));
        make.right.equalTo(cell.contentView.mas_right).offset(Scale(-16));
        make.bottom.equalTo(cell.contentView);
    }];
    return cell;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return self.dataSource.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    return Scale(60);
}




@end
